/*
   Modified by:
   Tuyen Luu Pham (lptuyen@gmail.com) 
*/

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 Blue
#property indicator_color2 DimGray
#property indicator_color3 Red
#property indicator_color4 Red
#property indicator_color5 DimGray
#property indicator_color6 LimeGreen
#property indicator_color7 LimeGreen

extern string MBFXSYS= "---MBFX SYSTEM---";
extern int Nmbr_Bars = 120;
extern int Order = 3;
extern double Ecart = 1.61803399;
double g_ibuf_92[];
double g_ibuf_96[];
double g_ibuf_100[];
double g_ibuf_104[];
double g_ibuf_108[];
double g_ibuf_112[];
double g_ibuf_116[];
double gda_120[20][20];
double gda_124[20];
double gda_128[20];
double gda_132[20];
int gi_136;
int gi_140;
int gi_144;
int gi_148;
int gi_152;
int gi_156;
int gi_160;
double gd_164;
double gd_172;
double gd_180;
double gd_188;
double gd_196;

// MBFX Timing

extern string MBFXTIMING= "---MBFX TIMING---";

extern int Len = 7;
extern double Filter = 0.0;
double g_ibuf_88[];//Yellow
double g_ibuf_93[];//Green
double g_ibuf_97[];//Red

extern string MBFXALERT= "---ALERT---";
extern bool ShowAlert=True;
extern bool EmailAlert=True;

double ld_0;
double ld_8;
double ld_16;
double ld_24;
double ld_32;
double ld_40;
double ld_48;
double ld_56;
double ld_64;
double ld_72;
double ld_80;
double ld_88;
double ld_96;
double ld_104;
double ld_112;
double ld_120;
double ld_128;
double ld_136;
double ld_144;
double ld_152;
double ld_160;
double ld_168;
double ld_176;
double ld_184;
double ld_192;
double ld_200;
double ld_208;
double ld_216;

//Program

double NormalisedPip;
int pTimeBar=0;
bool TouchedGreen=false;
bool TouchedRed=false;
bool YellowTiming=false;
int NewBarVar=false;

int init() {
   Comment("MBFX System");
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, g_ibuf_92);
   SetIndexBuffer(1, g_ibuf_96);
   SetIndexBuffer(2, g_ibuf_100);//Red
   SetIndexBuffer(3, g_ibuf_104);//Red
   SetIndexBuffer(4, g_ibuf_108);
   SetIndexBuffer(5, g_ibuf_112);//Lime Green
   SetIndexBuffer(6, g_ibuf_116);//Lime Green
   return (0);
}

int NewBar()
{
   if (Time[0] != pTimeBar)
   {
      pTimeBar = Time[0];
      return (1);
   }
   return (0);
}

int deinit() {
   Comment("");
   ObjectDelete("REG");
   ObjectDelete("X1");
   ObjectDelete("X2");
   ObjectDelete("X3");
   ObjectDelete("Z1");
   ObjectDelete("Z2");
   ObjectDelete("Z3");
   return (0);
}

int start() {
   if (Year() >= 2020) return (0);
   datetime l_time_0 = 0;
   SetIndexDrawBegin(0, Bars - Nmbr_Bars - 1);
   SetIndexDrawBegin(1, Bars - Nmbr_Bars - 1);
   SetIndexDrawBegin(2, Bars - Nmbr_Bars - 1);
   SetIndexDrawBegin(3, Bars - Nmbr_Bars - 1);
   SetIndexDrawBegin(4, Bars - Nmbr_Bars - 1);
   SetIndexDrawBegin(5, Bars - Nmbr_Bars - 1);
   SetIndexDrawBegin(6, Bars - Nmbr_Bars - 1);
   if (l_time_0 != Time[0]) {
      ObjectDelete("REG");
      ObjectDelete("X1");
      ObjectDelete("X2");
      ObjectDelete("X3");
      ObjectDelete("Z1");
      ObjectDelete("Z2");
      ObjectDelete("Z3");
      l_time_0 = Time[0];
   }
   
   NewBarVar=NewBar();
   
   //Timing
   ld_216 = Bars - Len - 1;
   ArrayResize(g_ibuf_88, ld_216);
   ArrayResize(g_ibuf_93, ld_216);
   ArrayResize(g_ibuf_97, ld_216);
   
   //MBFX System
   gi_152 = Order + 1;
   gda_124[1] = Nmbr_Bars + 1;
   for (gi_160 = 1; gi_160 <= gi_152 * 2 - 2; gi_160++) {
      gd_164 = 0;
      for (gi_156 = 0; gi_156 <= Nmbr_Bars; gi_156++) gd_164 += MathPow(gi_156, gi_160);
      gda_124[gi_160 + 1] = gd_164;
   }
   for (gi_160 = 1; gi_160 <= gi_152; gi_160++) {
      gd_164 = 0;
      for (gi_156 = 0; gi_156 <= Nmbr_Bars; gi_156++) {
         if (gi_160 == 1) gd_164 += (High[gi_156] + Low[gi_156]) / 2.0;
         else gd_164 += (High[gi_156] + Low[gi_156]) / 2.0 * MathPow(gi_156, gi_160 - 1);
      }
      gda_128[gi_160] = gd_164;
   }
   for (gi_140 = 1; gi_140 <= gi_152; gi_140++) {
      for (gi_136 = 1; gi_136 <= gi_152; gi_136++) {
         gi_144 = gi_136 + gi_140 - 1;
         gda_120[gi_136][gi_140] = gda_124[gi_144];
      }
   }
   for (gi_144 = 1; gi_144 <= gi_152 - 1; gi_144++) {
      gi_148 = 0;
      gd_188 = 0;
      for (gi_136 = gi_144; gi_136 <= gi_152; gi_136++) {
         if (MathAbs(gda_120[gi_136][gi_144]) > gd_188) {
            gd_188 = MathAbs(gda_120[gi_136][gi_144]);
            gi_148 = gi_136;
         }
      }
      if (gi_148 == 0) return (0);
      if (gi_148 != gi_144) {
         for (gi_140 = 1; gi_140 <= gi_152; gi_140++) {
            gd_196 = gda_120[gi_144][gi_140];
            gda_120[gi_144][gi_140] = gda_120[gi_148][gi_140];
            gda_120[gi_148][gi_140] = gd_196;
         }
         gd_196 = gda_128[gi_144];
         gda_128[gi_144] = gda_128[gi_148];
         gda_128[gi_148] = gd_196;
      }
      for (gi_136 = gi_144 + 1; gi_136 <= gi_152; gi_136++) {
         gd_180 = gda_120[gi_136][gi_144] / gda_120[gi_144][gi_144];
         for (gi_140 = 1; gi_140 <= gi_152; gi_140++) {
            if (gi_140 == gi_144) gda_120[gi_136][gi_140] = 0;
            else gda_120[gi_136][gi_140] = gda_120[gi_136][gi_140] - gd_180 * gda_120[gi_144][gi_140];
         }
         gda_128[gi_136] = gda_128[gi_136] - gd_180 * gda_128[gi_144];
      }
   }
   gda_132[gi_152] = gda_128[gi_152] / gda_120[gi_152][gi_152];
   for (gi_136 = gi_152 - 1; gi_136 >= 1; gi_136--) {
      gd_196 = 0;
      for (gi_140 = 1; gi_140 <= gi_152 - gi_136; gi_140++) {
         gd_196 += (gda_120[gi_136][gi_136 + gi_140]) * (gda_132[gi_136 + gi_140]);
         gda_132[gi_136] = 1 / gda_120[gi_136][gi_136] * (gda_128[gi_136] - gd_196);
      }
   }
   for (gi_156 = 0; gi_156 <= Nmbr_Bars; gi_156++) {
      gd_164 = 0;
      for (gi_144 = 1; gi_144 <= Order; gi_144++) gd_164 += (gda_132[gi_144 + 1]) * MathPow(gi_156, gi_144);
      g_ibuf_92[gi_156] = gda_132[1] + gd_164;
   }
   gd_172 = iStdDev(NULL, 0, Nmbr_Bars, 0, MODE_SMA, PRICE_HIGH, 0) * Ecart;
   for (gi_156 = 0; gi_156 <= Nmbr_Bars; gi_156++) {
      g_ibuf_104[gi_156] = g_ibuf_92[gi_156] + gd_172;//Red
      g_ibuf_100[gi_156] = g_ibuf_92[gi_156] + (g_ibuf_104[gi_156] - g_ibuf_92[gi_156]) / 1.382;//Low Line Red
      g_ibuf_96[gi_156] = g_ibuf_92[gi_156] + (g_ibuf_100[gi_156] - g_ibuf_92[gi_156]) / 1.618;
      g_ibuf_116[gi_156] = g_ibuf_92[gi_156] - gd_172;//Lime
      g_ibuf_112[gi_156] = g_ibuf_92[gi_156] - (g_ibuf_92[gi_156] - g_ibuf_116[gi_156]) / 1.382;//High Line Lime
      g_ibuf_108[gi_156] = g_ibuf_92[gi_156] - (g_ibuf_92[gi_156] - g_ibuf_112[gi_156]) / 1.618;
   }
   
   //Check Touch Red/Green Line

   if (NewBarVar==1)
   {
      if ((g_ibuf_112[1]>=Low[1]) && (TouchedGreen==False))
      {
         TouchedGreen=true;
      }   
      if ((g_ibuf_100[1]<=High[1]) && (TouchedRed==False))
      {
         TouchedRed=true;
      }   
   }
   
   ObjectCreate("REG", OBJ_ARROW, 0, Time[0], g_ibuf_92[0]);
   ObjectSet("REG", OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
   ObjectSet("REG", OBJPROP_COLOR, Blue);
   ObjectCreate("X1", OBJ_ARROW, 0, Time[0], g_ibuf_96[0]);
   ObjectSet("X1", OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
   ObjectSet("X1", OBJPROP_COLOR, DimGray);
   ObjectCreate("X2", OBJ_ARROW, 0, Time[0], g_ibuf_100[0]);
   ObjectSet("X2", OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
   ObjectSet("X2", OBJPROP_COLOR, Red);
   ObjectCreate("X3", OBJ_ARROW, 0, Time[0], g_ibuf_104[0]);
   ObjectSet("X3", OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
   ObjectSet("X3", OBJPROP_COLOR, Red);
   ObjectCreate("Z1", OBJ_ARROW, 0, Time[0], g_ibuf_108[0]);
   ObjectSet("Z1", OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
   ObjectSet("Z1", OBJPROP_COLOR, DimGray);
   ObjectCreate("Z2", OBJ_ARROW, 0, Time[0], g_ibuf_112[0]);
   ObjectSet("Z2", OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
   ObjectSet("Z2", OBJPROP_COLOR, LimeGreen);
   ObjectCreate("Z3", OBJ_ARROW, 0, Time[0], g_ibuf_116[0]);
   ObjectSet("Z3", OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
   ObjectSet("Z3", OBJPROP_COLOR, LimeGreen);
   
   //Timing
   
   for (int li_224 = ld_216; li_224 >= 0; li_224--) {
      if (ld_8 == 0.0) {
         ld_8 = 1.0;
         ld_16 = 0.0;
         if (Len - 1 >= 5) ld_0 = Len - 1.0;
         else ld_0 = 5.0;
         ld_80 = 100.0 * ((High[li_224] + Low[li_224] + Close[li_224]) / 3.0);
         ld_96 = 3.0 / (Len + 2.0);
         ld_104 = 1.0 - ld_96;
      } else {
         if (ld_0 <= ld_8) ld_8 = ld_0 + 1.0;
         else ld_8 += 1.0;
         ld_88 = ld_80;
         ld_80 = 100.0 * ((High[li_224] + Low[li_224] + Close[li_224]) / 3.0);
         ld_32 = ld_80 - ld_88;
         ld_112 = ld_104 * ld_112 + ld_96 * ld_32;
         ld_120 = ld_96 * ld_112 + ld_104 * ld_120;
         ld_40 = 1.5 * ld_112 - ld_120 / 2.0;
         ld_128 = ld_104 * ld_128 + ld_96 * ld_40;
         ld_208 = ld_96 * ld_128 + ld_104 * ld_208;
         ld_48 = 1.5 * ld_128 - ld_208 / 2.0;
         ld_136 = ld_104 * ld_136 + ld_96 * ld_48;
         ld_152 = ld_96 * ld_136 + ld_104 * ld_152;
         ld_56 = 1.5 * ld_136 - ld_152 / 2.0;
         ld_160 = ld_104 * ld_160 + ld_96 * MathAbs(ld_32);
         ld_168 = ld_96 * ld_160 + ld_104 * ld_168;
         ld_64 = 1.5 * ld_160 - ld_168 / 2.0;
         ld_176 = ld_104 * ld_176 + ld_96 * ld_64;
         ld_184 = ld_96 * ld_176 + ld_104 * ld_184;
         ld_144 = 1.5 * ld_176 - ld_184 / 2.0;
         ld_192 = ld_104 * ld_192 + ld_96 * ld_144;
         ld_200 = ld_96 * ld_192 + ld_104 * ld_200;
         ld_72 = 1.5 * ld_192 - ld_200 / 2.0;
         if (ld_0 >= ld_8 && ld_80 != ld_88) ld_16 = 1.0;
         if (ld_0 == ld_8 && ld_16 == 0.0) ld_8 = 0.0;
      }
      if (ld_0 < ld_8 && ld_72 > 0.0000000001) {
         ld_24 = 50.0 * (ld_56 / ld_72 + 1.0);
         if (ld_24 > 100.0) ld_24 = 100.0;
         if (ld_24 < 0.0) ld_24 = 0.0;
      } else ld_24 = 50.0;
      g_ibuf_88[li_224] = ld_24;//Yellow
      g_ibuf_93[li_224] = ld_24;//Green
      g_ibuf_97[li_224] = ld_24;//Red
      if (g_ibuf_88[li_224] > g_ibuf_88[li_224 + 1] - Filter) { g_ibuf_97[li_224] = EMPTY_VALUE; YellowTiming=false;}
      else {
         if (g_ibuf_88[li_224] < g_ibuf_88[li_224 + 1] + Filter) {g_ibuf_93[li_224] = EMPTY_VALUE;YellowTiming=false;}
         else {
            if (g_ibuf_88[li_224] == g_ibuf_88[li_224 + 1] + Filter) {
               g_ibuf_93[li_224] = EMPTY_VALUE;
               g_ibuf_97[li_224] = EMPTY_VALUE;
               
            }
         }
      }
   }
   
   //Check rule
   
   if (NewBarVar==0) return (0);
   if (NewBarVar==1)
   {
      if ((g_ibuf_93[2]== EMPTY_VALUE && g_ibuf_97[2]!= EMPTY_VALUE && g_ibuf_93[1]!= EMPTY_VALUE && g_ibuf_97[1]== EMPTY_VALUE)||
         ((g_ibuf_93[2]!= EMPTY_VALUE && g_ibuf_97[2]== EMPTY_VALUE && g_ibuf_93[1]== EMPTY_VALUE && g_ibuf_97[1]!= EMPTY_VALUE)))
      {
         YellowTiming=True;
      }   
      else YellowTiming=false;
   }
   
   if (Digits == 3 || Digits == 5) NormalisedPip = 10.0 * Point;
   else NormalisedPip = Point;
   RefreshRates();

   if (YellowTiming)//Yellow Timing
   {
      if (TouchedRed)//Sell Alert
      {
         TouchedRed=false;
         if (ShowAlert) Alert("MBFX Signal: SELL " + Symbol() + " On M" + Period() + " At " + DoubleToStr(Bid, Digits));
         if (EmailAlert) SendMail("MBFX Signal","MBFX Signal: SELL " + Symbol() + " On M" + Period() + " At " + DoubleToStr(Bid, Digits));
      }
      else if (TouchedGreen)//Buy Alert
      {
         TouchedGreen=false;
         if (ShowAlert) Alert("MBFX Signal: BUY " + Symbol() + " On M" + Period() + " At " + DoubleToStr(Ask, Digits));
         if (EmailAlert) SendMail("MBFX Signal","MBFX Signal: BUY " + Symbol() + " On M" + Period() + " At " + DoubleToStr(Ask, Digits));
      }
   }
   
   
   return (0);
}